config/routes.rb
# frozen_string_literal: true

Rails.application.routes.draw do
  get 'dashboards/show'
  resource :dashboard, only: %i[show]

  resources :stars
  resources :planets
  resources :moons

  root 'dashboards#show'
end

app/models/application_record.rb
# frozen_string_literal: true

class ApplicationRecord < ActiveRecord::Base
  primary_abstract_class
end

app/models/moon.rb
# frozen_string_literal: true

class Moon < ApplicationRecord
  belongs_to :planet

  validates :name, presence: true, uniqueness: { scope: :planet_id }
  validates :mass, presence: true, numericality: { greater_than: 0 }
  validates :distance_from_planet, presence: true, numericality: { greater_than: 0 }
  validates :orbital_period, presence: true, numericality: { greater_than: 0 }
  validates :tidally_locked, inclusion: [true, false], exclusion: [nil]
  validates :planet, associated: true
end

app/models/planet.rb
# frozen_string_literal: true

class Planet < ApplicationRecord
  belongs_to :star
  has_many :moons, dependent: :destroy

  enum category: { rocky: 0, gaseous: 1 }

  validates :name, presence: true, uniqueness: { scope: :star_id }
  validates :mass, presence: true, numericality: { greater_than: 0 }
  validates :distance_from_star, presence: true, numericality: { greater_than: 0 }
  validates :orbital_period, presence: true, numericality: { greater_than: 0 }
  validates :tidally_locked, inclusion: [true, false], exclusion: [nil]
  validates :category, presence: true
  validates :star, associated: true
end

app/models/star.rb
# frozen_string_literal: true

class Star < ApplicationRecord
  has_many :planets, dependent: :destroy

  enum :category, %i[O B A F G K M]

  validates :name, presence: true, uniqueness: true
  validates :mass, presence: true, numericality: { greater_than: 0 }
  validates :distance_from_earth, presence: true, numericality: { greater_than: 0 }
  validates :category, presence: true
end

app/controllers/application_controller.rb
# frozen_string_literal: true

class ApplicationController < ActionController::Base
end

app/controllers/dashboards_controller.rb
# frozen_string_literal: true

class DashboardsController < ApplicationController
  def show; end
end

app/controllers/moons_controller.rb
# frozen_string_literal: true

class MoonsController < ApplicationController
  before_action :set_moon, only: %i[show edit update destroy]

  def index
    @moons = Moon.order(:id).page(params[:page])
  end

  def show; end

  def new
    @moon = Moon.new
  end

  def edit; end

  def create
    @moon = Moon.new(moon_params)

    if @moon.save
      redirect_to @moon, notice: 'Moon was successfully created.'
    else
      render :new, status: :unprocessable_entity
    end
  end

  def update
    if @moon.update(moon_params)
      redirect_to @moon, notice: 'Moon was successfully updated.'
    else
      render :edit, status: :unprocessable_entity
    end
  end

  def destroy
    @moon.destroy
    redirect_to moons_url, notice: 'Moon was successfully destroyed.'
  end

  private

  def set_moon
    @moon = Moon.find(params[:id])
  end

  def moon_params
    params
      .require(:moon)
      .permit(:name, :mass, :planet_id, :distance_from_planet, :orbital_period, :tidally_locked)
  end
end

app/controllers/planets_controller.rb
# frozen_string_literal: true

class PlanetsController < ApplicationController
  before_action :set_planet, only: %i[show edit update destroy]

  def index
    @planets = Planet.order(:id).page(params[:page])
  end

  def show; end

  def new
    @planet = Planet.new
  end

  def edit; end

  def create
    @planet = Planet.new(planet_params)

    if @planet.save
      redirect_to @planet, notice: 'Planet was successfully created.'
    else
      render :new, status: :unprocessable_entity
    end
  end

  def update
    if @planet.update(planet_params)
      redirect_to @planet, notice: 'Planet was successfully updated.'
    else
      render :edit, status: :unprocessable_entity
    end
  end

  def destroy
    @planet.destroy
    redirect_to planets_url, notice: 'Planet was successfully destroyed.'
  end

  private

  def set_planet
    @planet = Planet.find(params[:id])
  end

  def planet_params
    params
      .require(:planet)
      .permit(:name, :mass, :star_id, :tidally_locked, :distance_from_star, :orbital_period, :category)
  end
end

app/controllers/stars_controller.rb
# frozen_string_literal: true

class StarsController < ApplicationController
  before_action :set_star, only: %i[show edit update destroy]

  def index
    @stars = Star.order(:id).page(params[:page])
  end

  def show; end

  def new
    @star = Star.new
  end

  def edit; end

  def create
    @star = Star.new(star_params)

    if @star.save
      redirect_to @star, notice: 'Star was successfully created.'
    else
      render :new, status: :unprocessable_entity
    end
  end

  def update
    if @star.update(star_params)
      redirect_to @star, notice: 'Star was successfully updated.'
    else
      render :edit, status: :unprocessable_entity
    end
  end

  def destroy
    @star.destroy
    redirect_to stars_url, notice: 'Star was successfully destroyed.'
  end

  private

  def set_star
    @star = Star.find(params[:id])
  end

  def star_params
    params
      .require(:star)
      .permit(:name, :mass, :distance_from_earth, :category)
  end
end

app/helpers/application_helper.rb
# frozen_string_literal: true

module ApplicationHelper
end

app/helpers/dashboards_helper.rb
# frozen_string_literal: true

module DashboardsHelper
end

app/helpers/moons_helper.rb
# frozen_string_literal: true

module MoonsHelper
end

app/helpers/planets_helper.rb
# frozen_string_literal: true

module PlanetsHelper
end

app/helpers/stars_helper.rb
# frozen_string_literal: true

module StarsHelper
end

app/views/application/_nav_item.html.erb
<% model ||= nil %>
<% key ||= model.model_name.to_s.pluralize.underscore %>
<% label = model.present? ? model.model_name.human(count: 2) : t("nav_items.#{ key }") %>
<% controller ||= key %>

<li class="nav-item">
  <%= link_to send("#{key}_path"), class: "nav-link #{'active' if controller_name == controller }" do %>
    <svg height="32" width="32"><use href="/images/icons.svg#<%= key %>"/></svg>
    <%= label %>
  <%- end %>
</li>

app/views/application/_sidebar.html.erb
<nav id="sidebarMenu" class="col-md-3 col-lg-2 d-md-block bg-light sidebar collapse">
  <div class="position-sticky pt-3">
    <ul class="nav flex-column">
      <%= render partial: 'nav_item', locals: { key: 'dashboard', controller: 'dashboards' } %>
      <%= render partial: 'nav_item', locals: { model: Star } %>
      <%= render partial: 'nav_item', locals: { model: Planet } %>
      <%= render partial: 'nav_item', locals: { model: Moon } %>
    </ul>
  </div>
</nav>

app/views/dashboards/_bodies_count.html.erb
<div class="g-col-4 card rounded-3 shadow-sm">
  <div class="card-header py-3">
    <h4 class="my-0 fw-normal"><%= t('dashboards.body_count.title') %></h4>
  </div>
  <div class="card-body">
    <table class="data-table table table-striped table-sm">
      <thead>
        <tr>
          <th><%= t('dashboards.common.type') %></th>
          <th><%= t('dashboards.common.count') %></th>
        </tr>
      </thead>
      <tbody>
        <tr>
          <td><%= Star.model_name.human(count: 2) %></td>
          <td>-</td>
        </tr>
        <tr>
          <td><%= Planet.model_name.human(count: 2) %></td>
          <td>-</td>
        </tr>
        <tr>
          <td><%= Moon.model_name.human(count: 2) %></td>
          <td>-</td>
        </tr>
      </tbody>
    </table>
  </div>
</div>

app/views/dashboards/_closest_systems_summary.html.erb
<div class="g-col-12 rounded-3 shadow-sm">
  <div class="card-header py-3">
    <h4 class="my-0 fw-normal"><%= t('dashboards.closest_systems.title') %></h4>
  </div>
  <div class="card-body">
    <table class="data-table table table-striped table-sm">
      <thead>
        <tr>
          <th><%= t('dashboards.common.distance') %></th>
          <th><%= t('dashboards.common.star') %></th>
          <th><%= t('dashboards.closest_systems.planets_count') %></th>
          <th><%= t('dashboards.closest_systems.biggest_planet') %></th>
          <th><%= t('dashboards.closest_systems.moons_count') %></th>
          <th><%= t('dashboards.closest_systems.biggest_moon') %></th>
        </tr>
      </thead>
      <tbody>
        <tr>
          <td>-</td>
          <td>-</td>
          <td>-</td>
          <td>-</td>
          <td>-</td>
          <td>-</td>
        </tr>
        <tr>
          <td>-</td>
          <td>-</td>
          <td>-</td>
          <td>-</td>
          <td>-</td>
          <td>-</td>
        </tr>
        <tr>
          <td>-</td>
          <td>-</td>
          <td>-</td>
          <td>-</td>
          <td>-</td>
          <td>-</td>
        </tr>
        <tr>
          <td>-</td>
          <td>-</td>
          <td>-</td>
          <td>-</td>
          <td>-</td>
          <td>-</td>
        </tr>
        <tr>
          <td>-</td>
          <td>-</td>
          <td>-</td>
          <td>-</td>
          <td>-</td>
          <td>-</td>
        </tr>
        <tr>
          <td>-</td>
          <td>-</td>
          <td>-</td>
          <td>-</td>
          <td>-</td>
          <td>-</td>
        </tr>
        <tr>
          <td>-</td>
          <td>-</td>
          <td>-</td>
          <td>-</td>
          <td>-</td>
          <td>-</td>
        </tr>
        <tr>
          <td>-</td>
          <td>-</td>
          <td>-</td>
          <td>-</td>
          <td>-</td>
          <td>-</td>
        </tr>
        <tr>
          <td>-</td>
          <td>-</td>
          <td>-</td>
          <td>-</td>
          <td>-</td>
          <td>-</td>
        </tr>
        <tr>
          <td>-</td>
          <td>-</td>
          <td>-</td>
          <td>-</td>
          <td>-</td>
          <td>-</td>
        </tr>
      </tbody>
    </table>
  </div>
</div>

app/views/dashboards/_habitable_candidates.html.erb
<div class="g-col-4 card rounded-3 shadow-sm">
  <div class="card-header py-3">
    <h4 class="my-0 fw-normal"><%= t('dashboards.habitable_candidates.title') %></h4>
  </div>
  <div class="card-body">
    <table class="data-table table table-striped table-sm">
      <thead>
        <tr>
          <th><%= Planet.model_name.human %></th>
          <th><%= Star.model_name.human %></th>
          <th><%= t('dashboards.common.distance') %></th>
        </tr>
      </thead>
      <tbody>
        <tr>
          <td>-</td>
          <td>-</td>
          <td>-</td>
        </tr>
        <tr>
          <td>-</td>
          <td>-</td>
          <td>-</td>
        </tr>
        <tr>
          <td>-</td>
          <td>-</td>
          <td>-</td>
        </tr>
        <tr>
          <td>-</td>
          <td>-</td>
          <td>-</td>
        </tr>
        <tr>
          <td>-</td>
          <td>-</td>
          <td>-</td>
        </tr>
      </tbody>
    </table>
  </div>
</div>

app/views/dashboards/_habitable_zones.html.erb
<div class="g-col-4 card rounded-3 shadow-sm">
  <div class="card-header py-3">
    <h4 class="my-0 fw-normal"><%= t('dashboards.habitable_zone.title') %></h4>
  </div>
  <div class="card-body">
    <table class="data-table table table-striped table-sm">
      <thead>
        <tr>
          <th><%= t('dashboards.common.type') %></th>
          <th><%= t('dashboards.common.count') %></th>
        </tr>
      </thead>
      <tbody>
        <tr>
          <td><%= t('dashboards.habitable_zone.too_close') %></td>
          <td>-</td>
        </tr>
        <tr>
          <td><%= t('dashboards.habitable_zone.sweet_spot') %></td>
          <td>-</td>
        </tr>
        <tr>
          <td><%= t('dashboards.habitable_zone.too_far') %></td>
          <td>-</td>
        </tr>
      </tbody>
    </table>
  </div>
</div>

app/views/moons/_form.html.erb
<%= form_with(model: moon, local: true) do |form| %>
  <% if moon.errors.any? %>
    <div id="error_explanation" class="alert alert-danger" role="alert">
      <h5><%= pluralize(moon.errors.count, 'error') %> prohibited this moon from being saved:</h5>
      <ul>
        <% moon.errors.full_messages.each do |message| %>
          <li><%= message %></li>
        <% end %>
      </ul>
    </div>
  <% end %>
  <div class="mb-3">
    <%= form.label :name %>
    <%= form.text_field :name, class: 'form-control' %>
  </div>
  <div class="mb-3">
    <%= form.label :mass %>
    <%= form.text_field :mass, class: 'form-control' %>
  </div>
  <div class="mb-3">
    <%= form.label :planet_id %>
    <%= form.select :planet_id, Planet.order(:name).pluck(:name, :id), {}, class: 'form-select' %>
  </div>
  <div class="mb-3">
    <%= form.label :distance_from_planet %>
    <%= form.text_field :distance_from_planet, class: 'form-control' %>
  </div>
  <div class="mb-3">
    <%= form.label :orbital_period %>
    <%= form.text_field :orbital_period, class: 'form-control' %>
  </div>
  <div class="mb-3 form-check">
    <%= form.check_box :tidally_locked, class: 'form-check-input' %>
    <%= form.label :tidally_locked, class: 'form-check-label'%>
  </div>
  <div class="actions">
    <%= form.submit t('actions.save'), class: 'btn btn-success min-width-btn' %>
    <%= link_to t('actions.back'), moons_path, class: 'btn btn-light min-width-btn' %>
  </div>
<% end %>

app/views/moons/edit.html.erb
<div class="d-flex justify-content-between flex-wrap flex-md-nowrap align-items-center pt-3 pb-2 mb-3 border-bottom">
  <h1 class="h2"><%= t('moon.actions.edit') %></h1>
</div>

<%= render 'form', moon: @moon %>

app/views/moons/index.html.erb
<div class="d-flex justify-content-between flex-wrap flex-md-nowrap align-items-center pt-3 pb-2 mb-3 border-bottom">
  <h1 class="h2"><%= Moon.model_name.human(count: 2) %></h1>
</div>

<table class="data-table table table-striped table-sm">
  <thead>
    <tr>
      <th><%= Moon.human_attribute_name('name') %></th>
      <th><%= Moon.human_attribute_name('planet_id') %></th>
      <th></th>
    </tr>
  </thead>
  <tbody>
    <% @moons.each do |moon| %>
      <tr>
        <td><%= moon.name %></td>
        <td><%= moon.planet.name %></td>
        <td>
          <%= link_to moon, class: 'btn btn-light' do %>
            <svg height="32" width="32"><use href="/images/icons.svg#show"/></svg>
          <%- end %>
          <%= link_to edit_moon_path(moon),class: 'btn btn-primary' do %>
            <svg height="32" width="32"><use href="/images/icons.svg#edit"/></svg>
          <%- end %>
          <%= link_to moon, method: :delete, data: { confirm: 'Are you sure?' }, class: 'btn btn-danger' do %>
            <svg height="32" width="32"><use href="/images/icons.svg#delete"/></svg>
          <%- end %>
        </td>
      </tr>
    <% end %>
  </tbody>
</table>

<%= paginate @moons, theme: 'bootstrap-5' %>

<%= link_to t('moon.actions.new'), new_moon_path,class: "btn btn-success min-width-btn" %>

app/views/moons/show.html.erb
<div class="d-flex justify-content-between flex-wrap flex-md-nowrap align-items-center pt-3 pb-2 mb-3 border-bottom">
  <h1 class="h2"><%= t('moon.actions.show') %></h1>
</div>

<%= form_with(model: @moon, local: true) do |form| %>
  <div class="mb-3">
    <%= form.label :name %>
    <%= form.text_field :name, class: 'form-control', readonly: true %>
  </div>
  <div class="mb-3">
    <%= form.label :mass %>
    <%= form.text_field :mass, class: 'form-control', readonly: true %>
  </div>
  <div class="mb-3">
    <%= form.label :planet_id %>
    <%= form.select :planet_id, Planet.order(:name).pluck(:name, :id), {}, class: 'form-select', disabled: true %>
  </div>
  <div class="mb-3">
    <%= form.label :distance_from_planet %>
    <%= form.text_field :distance_from_planet, class: 'form-control', readonly: true %>
  </div>
  <div class="mb-3">
    <%= form.label :orbital_period %>
    <%= form.text_field :orbital_period, class: 'form-control', readonly: true %>
  </div>
  <div class="mb-3 form-check">
    <%= form.check_box :tidally_locked, class: 'form-check-input', disabled: true %>
    <%= form.label :tidally_locked, class: "form-check-label" %>
  </div>
<% end %>
<%= link_to t('actions.edit'), edit_moon_path(@moon), class: 'btn btn-primary min-width-btn' %> 
<%= link_to t('actions.back'), :back, class: "btn btn-light min-width-btn" %>

app/views/planets/_form.html.erb
<%= form_with(model: planet, local: true) do |form| %>
  <% if planet.errors.any? %>
    <div id="error_explanation" class="alert alert-danger" role="alert">
      <h5><%= pluralize(planet.errors.count, 'error') %> prohibited this planet from being saved:</h5>
      <ul>
        <% planet.errors.full_messages.each do |message| %>
          <li><%= message %></li>
        <% end %>
      </ul>
    </div>
  <% end %>
  <div class="mb-3">
    <%= form.label :name %>
    <%= form.text_field :name, class: 'form-control' %>
  </div>
  <div class="mb-3">
    <%= form.label :mass %>
    <%= form.text_field :mass, class: 'form-control' %>
  </div>
  <div class="mb-3">
    <%= form.label :star_id %>
    <%= form.select :star_id, Star.order(:name).pluck(:name, :id), {}, class: 'form-select' %>
  </div>
  <div class="mb-3">
    <%= form.label :distance_from_star %>
    <%= form.text_field :distance_from_star, class: 'form-control' %>
  </div>
  <div class="mb-3">
    <%= form.label :orbital_period %>
    <%= form.text_field :orbital_period, class: 'form-control' %>
  </div>
  <div class="mb-3">
    <%= form.label :category %>
    <%= form.select :category,
                    options_for_select(Planet.categories.map {|key, value| [t("planet.category.#{key}"), Planet.categories.key(value)]}), 
                    {},
                    class: 'form-select' %>

  </div>
  <div class="mb-3 form-check">
    <%= form.check_box :tidally_locked, class: 'form-check-input' %>
    <%= form.label :tidally_locked, class: 'form-check-label'%>
  </div>
  <div class="actions">
    <%= form.submit t('actions.save'), class: 'btn btn-success min-width-btn' %>
    <%= link_to t('actions.back'), planets_path, class: 'btn btn-light min-width-btn' %>
  </div>
<% end %>

app/views/planets/index.html.erb
<div class="d-flex justify-content-between flex-wrap flex-md-nowrap align-items-center pt-3 pb-2 mb-3 border-bottom">
  <h1 class="h2"><%= Planet.model_name.human(count: 2) %></h1>
</div>

<table class="data-table table table-striped table-sm">
  <thead>
    <tr>
      <th><%= Planet.human_attribute_name('name') %></th>
      <th><%= Planet.human_attribute_name('star_id') %></th>
      <th></th>
    </tr>
  </thead>
  <tbody>
    <% @planets.each do |planet| %>
      <tr>
        <td><%= planet.name %></td>
        <td><%= planet.star.name %></td>
        <td>
          <%= link_to planet, class: 'btn btn-light' do %>
            <svg height="32" width="32"><use href="/images/icons.svg#show"/></svg>
          <%- end %>
          <%= link_to edit_planet_path(planet),class: 'btn btn-primary' do %>
            <svg height="32" width="32"><use href="/images/icons.svg#edit"/></svg>
          <%- end %>
          <%= link_to planet, method: :delete, data: { confirm: 'Are you sure?' }, class: 'btn btn-danger' do %>
            <svg height="32" width="32"><use href="/images/icons.svg#delete"/></svg>
          <%- end %>
        </td>
      </tr>
    <% end %>
  </tbody>
</table>

<%= paginate @planets, theme: 'bootstrap-5' %>

<%= link_to t('planet.actions.new'), new_planet_path,class: "btn btn-success min-width-btn" %>

app/views/planets/show.html.erb
<div class="d-flex justify-content-between flex-wrap flex-md-nowrap align-items-center pt-3 pb-2 mb-3 border-bottom">
  <h1 class="h2"><%= t('planet.actions.show') %></h1>
</div>

<%= form_with(model: @planet, local: true) do |form| %>
  <div class="mb-3">
    <%= form.label :name %>
    <%= form.text_field :name, class: 'form-control', readonly: true %>
  </div>
  <div class="mb-3">
    <%= form.label :mass %>
    <%= form.text_field :mass, class: 'form-control', readonly: true %>
  </div>
  <div class="mb-3">
    <%= form.label :star_id %>
    <%= form.select :star_id, Star.order(:name).pluck(:name, :id), {}, class: 'form-select', disabled: true %>
  </div>
  <div class="mb-3">
    <%= form.label :distance_from_star %>
    <%= form.text_field :distance_from_star, class: 'form-control', readonly: true %>
  </div>
  <div class="mb-3">
    <%= form.label :orbital_period %>
    <%= form.text_field :orbital_period, class: 'form-control', readonly: true %>
  </div>
  <div class="mb-3">
    <%= form.label :category %>
    <%= form.select :category,
                    options_for_select(Planet.categories.map {|key, value| [t("planet.category.#{key}"), Planet.categories.key(value)]}), 
                    {},
                    class: 'form-select',
                    disabled: true %>
  </div>
  <div class="mb-3 form-check">
    <%= form.check_box :tidally_locked, class: 'form-check-input', disabled: true %>
    <%= form.label :tidally_locked, class: "form-check-label" %>
  </div>
<% end %>

<h2>Luas</h2>
<table class="data-table table table-striped table-sm">
  <thead>
    <tr>
      <th><%= Moon.human_attribute_name('name') %></th>
      <th><%= Moon.human_attribute_name('mass') %></th>
      <th></th>
    </tr>
  </thead>
  <tbody>
    <% @planet.moons.each do |moon| %>
      <tr>
        <td><%= moon.name %></td>
        <td><%= moon.mass %></td>
        <td>
          <%= link_to moon, class: 'btn btn-light' do %>
            <svg height="32" width="32"><use href="/images/icons.svg#show"/></svg>
          <%- end %>
          <%= link_to edit_moon_path(moon),class: 'btn btn-primary' do %>
            <svg height="32" width="32"><use href="/images/icons.svg#edit"/></svg>
          <%- end %>
          <%= link_to moon, method: :delete, data: { confirm: 'Are you sure?' }, class: 'btn btn-danger' do %>
            <svg height="32" width="32"><use href="/images/icons.svg#delete"/></svg>
          <%- end %>
        </td>
      </tr>
    <% end %>
  </tbody>
</table>

<%= link_to t('actions.edit'), edit_planet_path(@planet), class: 'btn btn-primary min-width-btn' %> 
<%= link_to t('actions.back'), :back, class: "btn btn-light min-width-btn" %>

app/views/stars/_form.html.erb
<%= form_with(model: star, local: true) do |form| %>
  <% if star.errors.any? %>
    <div id="error_explanation" class="alert alert-danger" role="alert">
      <h5><%= pluralize(star.errors.count, 'error') %> prohibited this star from being saved:</h5>
      <ul>
        <% star.errors.full_messages.each do |message| %>
          <li><%= message %></li>
        <% end %>
      </ul>
    </div>
  <% end %>
  <div class="mb-3">
    <%= form.label :name %>
    <%= form.text_field :name, class: 'form-control' %>
  </div>
  <div class="mb-3">
    <%= form.label :mass %>
    <%= form.text_field :mass, class: 'form-control' %>
  </div>
  <div class="mb-3">
    <%= form.label :category %>
    <%= form.select :category,
                    options_for_select(Star.categories.map {|key, value| [key.to_s, Planet.categories.key(value)]}), 
                    {},
                    class: 'form-select' %>

  </div>
  <div class="actions">
    <%= form.submit t('actions.save'), class: 'btn btn-success min-width-btn' %>
    <%= link_to t('actions.back'), stars_path, class: 'btn btn-light min-width-btn' %>
  </div>
<% end %>

app/views/stars/index.html.erb
<div class="d-flex justify-content-between flex-wrap flex-md-nowrap align-items-center pt-3 pb-2 mb-3 border-bottom">
  <h1 class="h2"><%= Star.model_name.human(count: 2) %></h1>
</div>

<table class="data-table table table-striped table-sm">
  <thead>
    <tr>
      <th><%= Star.human_attribute_name('name') %></th>
      <th><%= Star.human_attribute_name('mass') %></th>
      <th></th>
    </tr>
  </thead>
  <tbody>
    <% @stars.each do |star| %>
      <tr>
        <td><%= star.name %></td>
        <td><%= star.mass %></td>
        <td>
          <%= link_to star, class: 'btn btn-light' do %>
            <svg height="32" width="32"><use href="/images/icons.svg#show"/></svg>
          <%- end %>
          <%= link_to edit_star_path(star),class: 'btn btn-primary' do %>
            <svg height="32" width="32"><use href="/images/icons.svg#edit"/></svg>
          <%- end %>
          <%= link_to star, method: :delete, data: { confirm: 'Are you sure?' }, class: 'btn btn-danger' do %>
            <svg height="32" width="32"><use href="/images/icons.svg#delete"/></svg>
          <%- end %>
        </td>
      </tr>
    <% end %>
  </tbody>
</table>

<%= paginate @stars, theme: 'bootstrap-5' %>

<%= link_to t('star.actions.new'), new_star_path,class: "btn btn-success min-width-btn" %>

app/views/stars/show.html.erb
<div class="d-flex justify-content-between flex-wrap flex-md-nowrap align-items-center pt-3 pb-2 mb-3 border-bottom">
  <h1 class="h2"><%= t('star.actions.show') %></h1>
</div>

<%= form_with(model: @star, local: true) do |form| %>
  <div class="mb-3">
    <%= form.label :name %>
    <%= form.text_field :name, class: 'form-control', readonly: true %>
  </div>
  <div class="mb-3">
    <%= form.label :mass %>
    <%= form.text_field :mass, class: 'form-control', readonly: true %>
  </div>
<% end %>

<h2><%= Planet.model_name.human(count: 2) %></h2>
<table class="data-table table table-striped table-sm">
  <thead>
    <tr>
      <th><%= Planet.human_attribute_name('name') %></th>
      <th><%= Planet.human_attribute_name('mass') %></th>
      <th><%= Planet.human_attribute_name('category') %></th>
      <th></th>
    </tr>
  </thead>
  <tbody>
    <% @star.planets.each do |planet| %>
      <tr>
        <td><%= planet.name %></td>
        <td><%= planet.mass %></td>
        <td><%= t("planet.category.#{planet.category}") %></td>
        <td>
          <%= link_to planet, class: 'btn btn-light' do %>
            <svg height="32" width="32"><use href="/images/icons.svg#show"/></svg>
          <%- end %>
          <%= link_to edit_planet_path(planet),class: 'btn btn-primary' do %>
            <svg height="32" width="32"><use href="/images/icons.svg#edit"/></svg>
          <%- end %>
          <%= link_to planet, method: :delete, data: { confirm: 'Are you sure?' }, class: 'btn btn-danger' do %>
            <svg height="32" width="32"><use href="/images/icons.svg#delete"/></svg>
          <%- end %>
        </td>
      </tr>
    <% end %>
  </tbody>
</table>

<%= link_to t('actions.edit'), edit_star_path(@star), class: 'btn btn-primary min-width-btn' %> 
<%= link_to t('actions.back'), :back, class: "btn btn-light min-width-btn" %>